/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released April 1, 2001
 * 
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):
 *   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
 *   Neil Pryde <NeilPryde92651@netscape.net> (well I'm just HJ's typewriter)
 * 
 */

var prefErrors = 0;
var newPrefsAdded = 0;

////////////////////////////////////////////////////////////////////////////////
// This function initializes the preferences for MultiZilla. A missing pref 
// setting will be added fully automatically to prevent failures.
////////////////////////////////////////////////////////////////////////////////
function initPreferences()
{
  if (!pref) { // Make sure 'pref' is initialized (this seems to fail in Netscape 7)
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    pref = prefService.getBranch(null);
  }
  if (readMyPref("multizilla.prefs.checked", "bool", false))
    return; // Bail out if already checked. This should improve our startup time

  // -- prefs.js --------------------------------------------------------------------------------
  readMyPref("multizilla.bookmark.close-remaining", "bool", false);
  readMyPref("multizilla.bookmark.folders", "int", 15);
  readMyPref("multizilla.bookmark.folders.confirmation", "int", 3);
  readMyPref("multizilla.bookmark.groups", "int", 15);
  readMyPref("multizilla.bookmark.groups.confirmation", "int", 3);

  readMyPref("multizilla.bookmark.loadInBackground", "bool", false);
  readMyPref("multizilla.bookmark.menuitem.allow-middleclick", "bool", true);
  readMyPref("multizilla.bookmark.menuitem.middleclick-closepopups", "bool", true);
  readMyPref("multizilla.browsersession.skip.navigator.startup", "bool", true);
  readMyPref("multizilla.browsersession.skip.confirm-single-window", "bool", false);
 
  readMyPref("multizilla.browser.docShell.allowPlugins", "bool", true);
  readMyPref("multizilla.browser.docShell.allowJavascript", "bool", true);
  readMyPref("multizilla.browser.docShell.allowMetaRedirects", "bool", true);
  readMyPref("multizilla.browser.docShell.allowSubframes", "bool", true);
  readMyPref("multizilla.browser.docShell.allowImages", "bool", true);

  readMyPref("multizilla.check.webtools", "bool", true);  

  readMyPref("multizilla.confirm.quit", "int", 11);
  readMyPref("multizilla.confirm.quit-session", "bool", false);
  readMyPref("multizilla.confirm.content-blocker.all", "bool", false);
  readMyPref("multizilla.confirm.content-blocker.other-domains", "bool", false);
  readMyPref("multizilla.confirm.content-blocker.blockall", "bool", false);
  readMyPref("multizilla.confirm.content-blocker.keepPermissions", "bool", true);

  readMyPref("multizilla.content-blocker.warn", "bool", true);
  readMyPref("multizilla.content-blocker.behavior", "int", 0);
  readMyPref("multizilla.content-blocker.mimetypes.blocked", "bool", false);
  readMyPref("multizilla.content-blocker.mimetypes.keep", "bool", true);
  readMyPref("multizilla.content-blocker.mimetypes", "string", "video/quicktime, application/x-shockwave-flash, application/futuresplash");

  readMyPref("multizilla.document.context-menu.behavior", "int", 1);
  readMyPref("multizilla.dnd.loadInBackground", "bool", false);
  readMyPref("multizilla.dnd.tabstripdrops.selected", "bool", true);

  readMyPref("multizilla.forced.autocomplete", "bool", true);
  readMyPref("multizilla.forced.autocomplete.onsubmit-remove", "bool", false);

  readMyPref("multizilla.fullscreen.enabled", "bool", true);
  readMyPref("multizilla.fullscreen.enable.menubar", "bool", false);
  readMyPref("multizilla.fullscreen.enable.personaltoolbar", "bool", false);
  readMyPref("multizilla.fullscreen.enable.status-bar", "bool", true);
  // readMyPref("multizilla.fullscreen.enable.[toolbar id]", "bool", [true/false]);
  readMyPref("multizilla.fullscreen.first-browserwindow-only", "bool", true);
  readMyPref("multizilla.fullscreen.disable.chromeless", "bool", true);
  readMyPref("multizilla.fullscreen.enable.linktoolbar", "bool", false);
  readMyPref("multizilla.fullscreen.re-enable-chrome", "bool", true);

  readMyPref("multizilla.integrated.toolbar", "bool", false);
  readMyPref("multizilla.integrated.toolbar-notify", "bool", true);
  readMyPref("multizilla.integrated.toolbar.hide-all-other-buttons", "bool", true);

  readMyPref("multizilla.mac-ctrl-left-right.behavior", "bool", false);
  readMyPref("multizilla.mouse-middle-click.close", "bool", true);
  readMyPref("multizilla.tabstrip.middle-click-action", "int", 0);

  readMyPref("multizilla.newtabfor.bookmarks", "bool", false);
  readMyPref("multizilla.newtabfor.ctrl-n", "bool", true);
  readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
  readMyPref("multizilla.newtabfor.external-links", "bool", true);
  readMyPref("multizilla.newtabfor.locationbar", "bool", false);
  readMyPref("multizilla.newtabfor.mailnews", "bool", false);
  readMyPref("multizilla.newtabfor.native-applications", "bool", true);
  readMyPref("multizilla.newtabfor.personal-toolbar", "bool", false);
  readMyPref("multizilla.newtabfor.sidebar", "bool", false);
  readMyPref("multizilla.newtabfor.view-source", "bool", true);
  readMyPref("multizilla.newtabfor.windowopen", "bool", true);

  readMyPref("multizilla.perm-manager.default-manager", "string", "cookieManager");
  readMyPref("multizilla.showbutton.privacymanager", "bool", true);

  readMyPref("multizilla.preferred.fornewtabs", "bool", false);
  readMyPref("multizilla.preferred.location", "string", "http://multizilla.mozdev.org/index.html");
  readMyPref("multizilla.preferred.type", "int", 0);

  readMyPref("multizilla.privacy.clear-on-exit.diskcache", "bool", false);
  readMyPref("multizilla.privacy.clear-on-exit.locationbar", "bool", false);
  readMyPref("multizilla.privacy.clear-on-exit.history", "bool", false);
  readMyPref("multizilla.privacy.clear-on-exit.cookies", "bool", false);
  readMyPref("multizilla.privacy.clear-on-exit.downloads", "bool", false);
  readMyPref("multizilla.privacy.clear-on-exit.formdata", "bool", false);
  readMyPref("multizilla.privacy.clear-on-exit.passwords", "bool", false);
  readMyPref("multizilla.privacy.clear-on-exit.confirm", "bool", false);

  readMyPref("multizilla.prevent.double", "bool", true);
  readMyPref("multizilla.refspoof.spoofing", "int", 1)
  readMyPref("multizilla.refspoof.spoofurl", "url", "http://ref.spoof.org/refspoof.cgi");
  readMyPref("multizilla.remove.form-target", "bool", false);
  // Buttons on the navigation toolbar
  readMyPref("multizilla.showbutton.qpmenu", "bool", false);
  readMyPref("multizilla.showbutton.clearlocbar", "bool", false);
  // Buttons on the MultiZilla toolbar
  readMyPref("multizilla.showbutton.mzmenubutton", "bool", true);
  readMyPref("multizilla.showbutton.newtab", "bool", true);
  readMyPref("multizilla.showbutton.tabpos", "bool", true);
  readMyPref("multizilla.showbutton.tabstrip", "bool", true);
  readMyPref("multizilla.showbutton.tabmanager", "bool", true);
  readMyPref("multizilla.showbutton.quickprefmenu", "bool", true);
  readMyPref("multizilla.showbutton.update", "bool", true);
  readMyPref("multizilla.showbutton.jsconsole", "bool", true);
  readMyPref("multizilla.showbutton.inspector", "bool", true);
  readMyPref("multizilla.showbutton.permmanager", "bool", true);
  readMyPref("multizilla.showbutton.closeThis", "bool", true);
  readMyPref("multizilla.showbutton.closeOther", "bool", true);
  readMyPref("multizilla.showbutton.closeAll", "bool", true);
  // Button end
  readMyPref("multizilla.tabbar.closebutton", "bool", false);
  readMyPref("multizilla.tabbar.newbutton", "bool", false);
  readMyPref("multizilla.tabbar.middle-click-opentab", "int", 0);

  readMyPref("multizilla.tabs.automatic-selection", "int", 0);
  readMyPref("multizilla.tabs.blank-tab-first", "bool", true);
  readMyPref("multizilla.tabs.confirm-close", "bool", true);
  readMyPref("multizilla.tabs.confirm-close-other", "bool", true);
  readMyPref("multizilla.tabs.ctrl-click.url-to-clipboard", "bool", false);
  readMyPref("multizilla.tabs.cropping", "int", 2);
  readMyPref("multizilla.tabs.duplicate-permissions", "bool", false);
  readMyPref("multizilla.tabs.focus-order", "int", 0);
  readMyPref("multizilla.tabs.groupmark", "string", "");
  readMyPref("multizilla.tabs.iconclose", "bool", true);
  readMyPref("multizilla.tabs.init-permissions", "bool", false);
  readMyPref("multizilla.tabs.insertstyle", "int", 1);
  readMyPref("multizilla.tabs.mintabwidth", "int", 25);
  readMyPref("multizilla.tabs.meta-refresh", "int", 0);
  readMyPref("multizilla.tabs.ontop", "bool", true);
  readMyPref("multizilla.tabs.open-order", "int", 0);
  readMyPref("multizilla.tabs.save-session.behavior", "int", 3);
  readMyPref("multizilla.tabs.restore-session.behavior", "int", 3);
  readMyPref("multizilla.tabs.restore-session.notify", "bool", false);
  readMyPref("multizilla.tabs.status-leds", "bool", true);
  readMyPref("multizilla.tabs.tabwidth", "int", 175);
  readMyPref("multizilla.tabs.title", "bool", true);

  readMyPref("multizilla.window-open.redirector", "bool", false);
  readMyPref("multizilla.window-open.behavior", "int", 2);
  readMyPref("multizilla.window-open.override-features", "bool", false);
  readMyPref("multizilla.window-open.features", "int", 2047);
  readMyPref("multizilla.window-open.display-failures", "bool", false);
  readMyPref("multizilla.window-open.javascript-in-tab", "bool", false);
  readMyPref("multizilla.tabs.display-popup-icon", "bool", true);
  readMyPref("multizilla.tabs.remove-popup-icon-delay", "int", 0);

  var mPrefChecked = (newPrefsAdded == 0);
  writePref("bool", "multizilla.prefs.checked", mPrefChecked);

  if (prefErrors)
    alert(mzGetTextFromBundle("corruptPref"));
}
////////////////////////////////////////////////////////////////////////////////
// this function returns true, false or the value for the given pref setting
////////////////////////////////////////////////////////////////////////////////
function readMyPref(prefIdentifier, prefType, defaultSetup)
{
  var prefValue;

  switch(prefType)
    {
      case "bool": 
        {
          try {
            prefValue = pref.getBoolPref(prefIdentifier); 
          } catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup);
            return Boolean(defaultSetup);
          }
          return Boolean(prefValue);
        }
      case "int":
        {
          try {
            prefValue = pref.getIntPref(prefIdentifier);
          } catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup);
            return defaultSetup;
          }
          return prefValue;
        }
      case "string":
        {
          try {
            prefValue = pref.getComplexValue(prefIdentifier, Components.interfaces.nsISupportsString);
          } catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup);
            return (defaultSetup);
          }
          return prefValue.data.length ? prefValue.data : defaultSetup;
        }
      case "char":
        {
          try {
            prefValue = pref.getCharPref(prefIdentifier);
          } catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup);
          }
	      return prefValue ? prefValue : defaultSetup;
        }
      case "url":
        {
          try {
            prefValue = pref.getComplexValue(prefIdentifier, Components.interfaces.nsIPrefLocalizedString);
          } catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup);
            return (defaultSetup);
          }
          return prefValue.data.length ? prefValue.data : defaultSetup;
        }
      default:
        {
          dump('readMyPref(): Unsupported pref type "'+prefType+'" used\n');
        }
    }
  return (defaultSetup);
}
////////////////////////////////////////////////////////////////////////////////
function fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup) 
{
  if (pref.prefHasUserValue(prefIdentifier)) {
    pref.clearUserPref(prefIdentifier);
    dump("\nError: prefType = "+prefType+"\nPrefIdentifier = "+prefIdentifier+"\nprefValue = "+defaultSetup);
    prefErrors++;
  }
  writePref(prefType, prefIdentifier, defaultSetup);
  newPrefsAdded++;
}
////////////////////////////////////////////////////////////////////////////////
// this function write the given preference type, 
////////////////////////////////////////////////////////////////////////////////
function writePref(prefType, prefString, prefValue)
{
  try {
    switch (prefType) {
      case "bool":
        {
          pref.setBoolPref(prefString, prefValue);
          break;
        }
      case "int":
        {
          pref.setIntPref(prefString, prefValue);
          break;
        }
      case "string":
        {
          var str;
          str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
          str.data = prefValue;
          pref.setComplexValue(prefString, Components.interfaces.nsISupportsString, str);
          break;
        }
      case "url":
        {
          pref.setComplexValue(prefString, Components.interfaces.nsIPrefLocalizedString, prefValue);
          break;
        }
      case "char":
        {
          pref.setCharPref(prefString, prefValue);
          break;
        }
      default:
        {
          dump('writePref(): Unsupported pref type "'+prefType+'" used\n');
        }
    }
  }
  catch (ex) { // die silently 
  }
}
////////////////////////////////////////////////////////////////////////////////
function toggleBoolPref(aPrefIdentifier, aPrefType, aDefaultValue)
{
  var aPrefValue = readMyPref(aPrefIdentifier, aPrefType, aDefaultValue);
  writePref(aPrefType, aPrefIdentifier, !aPrefValue);
}
////////////////////////////////////////////////////////////////////////////////
// This function checks the vendor pref settings and add/replace them with the
// correct values (match HTTP UserAgent string to Menu/Help/About MultiZilla).
////////////////////////////////////////////////////////////////////////////////
function checkVendorPrefs()
{
  const prefBranch = "general.useragent.";
  var MultiZillaVersion = getBrowser().mVersion+getBrowser().mVersionRev;
  var vendor = readMyPref(prefBranch + "vendor", "string", "MultiZilla");
  var vendorSub = readMyPref(prefBranch + "vendorSub", "string", MultiZillaVersion);

  if (vendor != "MultiZilla")
    writePref("string", prefBranch + "vendor", "MultiZilla");
  if (vendorSub != MultiZillaVersion)
    writePref("string", prefBranch + "vendorSub", MultiZillaVersion);

  checkGeneralUseragentMiscPref();
}
////////////////////////////////////////////////////////////////////////////////
function checkGeneralUseragentMiscPref()
{
  const prefId = "general.useragent.misc";

  try {
    if (pref.prefHasUserValue(prefId))
      pref.clearUserPref(prefId);
  } catch(ex) {
  }
}

