/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001-2004
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
*/

/* 
  modified function from navigator.js with one exception
  function getReferrer(doc) because that belong to contentAreaUtils.js.
  this was added for Phoenix support: addPrefListener(observer)
*/

////////////////////////////////////////////////////////////////////////// 
function OpenBookmarkURL(node, datasource, event)
{
  if (node.nodeName == "menu")
    return;

  if (event && (node.id == "bookmarks_groupmark" || node.id == "PT_bookmarks_groupmark" || node.id == "bookmarks_button_groupmark"))
    return;

  var prefValue = readMyPref("multizilla.bookmark.groups", "int", 0);
  // XXX: new code for bug 3319
  if (prefValue & 1 && node.parentNode.parentNode.getAttribute("group") && !node.hasAttribute("id"))
    node = node.parentNode.parentNode;
  if (!node.hasChildNodes() && node.getAttribute("group") && node.hasAttribute("id")) {
    var tabCount = gBrowser.mPanelContainer.childNodes.length-1;
    var newTabs = readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
    var closeRemaining = readMyPref("multizilla.bookmark.close-remaining", "bool", false);
    // open dialog for settings
    if (newTabs == 2) {
      window.openDialog("chrome://multiviews/content/multiviewsAskSettings.xul", "_blank", "chrome,modal,centerscreen", getBrowser(), closeRemaining);
      newTabs = gBrowser.mNewTabs;
      closeRemaining = gBrowser.mRemoveRemaining;
      if (gBrowser.mNewTabs == -1)
        return;
    }
    else newTabs = (newTabs == 1) ? true : false;
    var startTab = newTabs ? (tabCount+1) : 0;
    OpenBookmarkFolder(node, datasource, (tabCount+1), newTabs, false, false);
    gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[startTab];

    if (closeRemaining) {
      if (newTabs) {
        /* startTab = gBrowser.mTabList[startTab].ordinal-1;
        for (i = startTab; i >= 0; i--)
          gBrowser.removeTab(gBrowser.mTabList[i]); */
      }
      else {
        for (var i = tabCount; i >= tabIndex; i--)
          gBrowser.removeTab(gBrowser.mTabList[i]);
      }
    }
    return;
  }
  var allowMiddleClicks = readMyPref("multizilla.bookmark.menuitem.allow-middleclick", "bool", false);

  if (node.getAttribute("container") == "true" || (node.nodeName == "menuitem" && event && event.button == 1 && !allowMiddleClicks) )
    return;
  var url = node.getAttribute("id");
  // testCode(url);
  if (!url)
    return;

  try {
    if (datasource) {
      var src = RDF.GetResource(url);
      var prop = RDF.GetResource("http://home.netscape.com/NC-rdf#URL");
      var target = datasource.GetTarget(src, prop, true);
      if (target) {
        target = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
        if (target)
          url = target;
      }
    }
  } catch (ex) {
    return;
  }
  if (url.substring(0, 3) == "NC:")
    return;
  if (_content) {
    if (preventDupeTab(url))
      return;
    var backupNode = node; // save original

    while (node.nodeName != "toolbarbutton" && node.nodeName != "menubar")
      node = node.parentNode;
    var shiftKey = false;
    var ctrlKey = false;
    var button = false;

    if (event) {
      shiftKey = event.shiftKey;
      ctrlKey = event.ctrlKey;
      button = event.button;
    }
    if ((node.nodeName == "menubar" && pref && pref.getBoolPref("multizilla.newtabfor.bookmarks") && !shiftKey) ||
        (node.nodeName == "toolbarbutton" /* XXX: see bug 2675 && node.id != "bookmarks-button" */ && 
        pref && pref.getBoolPref("multizilla.newtabfor.personal-toolbar") && !shiftKey) || 
        ctrlKey || button == 1) {
      if (url.substring(0,10) == "javascript") {
	    if (url.indexOf("getSelection(") == -1)
          loadURI(url, null);
        else
          setTimeout(function() { loadURI(url, null) }, 0, gBrowser.selectedTab = getBrowser().addTab());
      }
      else {
        var tab = null;
        var browser = checkForBlankTab();

        if (browser) {
          browser.loadURI(getShortcutOrURI(url, null));
          tab = gBrowser.getTabForBrowser(browser);
        }
        else
          tab = gBrowser.addTab(getShortcutOrURI(url));

        if (!readMyPref("multizilla.bookmark.loadInBackground", "bool", false))
          gBrowser.selectedTab = tab;
      }
    }
    else {
      loadURI(url, null);
      _content.focus();
    }
    // Do we need to close menupopups?
    if (allowMiddleClicks && readMyPref("multizilla.bookmark.menuitem.middleclick-closepopups", "bool", true)) {
      node = backupNode;
      while (node.nodeName != "toolbarbutton" && node.nodeName != "menubar") {
        node = node.parentNode;
        if (node.nodeName == "menupopup")
          node.hidePopup();
      }
      // We need to 'Close" the Bookmarks button on the menubar
      if (node.nodeName == "menubar") {
        var menu = document.getElementById("BookmarksMenu");
        menu.setAttribute("_moz-menuactive", false);
      }
    }
  }
  else
    openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", url);
}
//////////////////////////////////////////////////////////////////////////
function BrowserLoadURL(aTriggeringEvent)
{
  var url = gURLBar.value;
  if (url.match(/^view-source:/)) {
    BrowserViewSourceOfURL(url.replace(/^view-source:/, ""), null, null);
  } else {
    // Check the pressed modifiers: (also see bug 97123)
    // Modifier Mac | Modifier PC | Action
    // -------------+-------------+-----------
    // Command      | Control     | New Window/Tab
    // Shift+Cmd    | Shift+Ctrl  | New Window/Tab behind current one
    // Option       | Shift       | Save URL (show Filepicker)

    // If false, the save modifier is Alt, which is Option on Mac.
    var modifierIsShift = true;
    try {
      modifierIsShift = pref.getBoolPref("ui.key.saveLink.shift");
    }
    catch (ex) {}

    var shiftPressed = false;
    var saveModifier = false; // if the save modifier was pressed
    if (aTriggeringEvent && 'shiftKey' in aTriggeringEvent &&
        'altKey' in aTriggeringEvent) {
      saveModifier = modifierIsShift ? aTriggeringEvent.shiftKey
                     : aTriggeringEvent.altKey;
      shiftPressed = aTriggeringEvent.shiftKey;
    }

    var browser = getBrowser();
    url = getShortcutOrURI(url);
    var newTab = readMyPref("multizilla.newtabfor.locationbar", "bool", false);
    // Accept both Control and Meta (=Command) as New-Window-Modifiers
    if ((aTriggeringEvent &&
        (('ctrlKey' in aTriggeringEvent && aTriggeringEvent.ctrlKey) ||
         ('metaKey' in aTriggeringEvent && aTriggeringEvent.metaKey))) || newTab) {
      // Check if user requests Tabs instead of windows
      var openTab = false;
      try {
        openTab = pref.getBoolPref("browser.tabs.opentabfor.urlbar");
      }
      catch (ex) {}

      if (openTab || newTab) {
        // Open link in new tab
        var t = browser.addTab(url);

        // Focus new tab unless shift is pressed
        if (!shiftPressed) {
          browser.userTypedValue = null;
          browser.selectedTab = t;
        }
      } else {
        // Open a new window with the URL
        var newWin = openDialog(getBrowserURL(), "_blank", "all,dialog=no", url);
        // Reset url in the urlbar, copied from handleURLBarRevert()
        var oldURL = browser.currentURI.spec;
        if (oldURL != "about:blank") {
          gURLBar.value = oldURL;
          SetPageProxyState("valid", null);
        } else
          gURLBar.value = "";

        browser.userTypedValue = null;

        // Focus old window if shift was pressed, as there's no
        // way to open a new window in the background
        // XXX this doesn't seem to work
        if (shiftPressed) {
          //newWin.blur();
          content.focus();
        }
      }
    } else if (saveModifier) {
      try {
        // Firstly, fixup the url so that (e.g.) "www.foo.com" works
        const nsIURIFixup = Components.interfaces.nsIURIFixup;
        if (!gURIFixup)
          gURIFixup = Components.classes["@mozilla.org/docshell/urifixup;1"]
                                .getService(nsIURIFixup);
        url = gURIFixup.createFixupURI(url, nsIURIFixup.FIXUP_FLAGS_MAKE_ALTERNATE_URI).spec;
        // Open filepicker to save the url
        saveURL(url, "");
      }
      catch(ex) {
        // XXX Do nothing for now.
        // Do we want to put up an alert in the future?  Mmm, l10n...
      }
    } else {
      // No modifier was pressed, load the URL normally and
      // focus the content area
      loadURI(url);
      content.focus();
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function LoadBookmarksCallback() // for mozilla v1.4+
{
  initServices();
  initBMService();
  BMSVC.readBookmarks();
  var bt = document.getElementById("bookmarks-ptf");

  if (bt)
    bt.database.AddObserver(BookmarksToolbarRDFObserver);
  window.addEventListener("resize", BookmarksToolbar.resizeFunc, false);
  controllers.appendController(BookmarksMenuController);

  var personalToolbar = document.getElementById("bookmarks-ptf"); // (fix for bug 4327)
  personalToolbar.builder.rebuild();
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroup(element, datasource, id)
{
  if (!datasource)
    return;
  if (element)
    id = element.getAttribute("id");
  else {
    id = readMyPref("multizilla.tabs.groupmark", "string", null);
    if (!id)
      return;
  }
  var resource = RDF.GetResource(id, true);
  OpenBookmarkGroupFromResource(resource, datasource);
}
//////////////////////////////////////////////////////////////////////////
// This is added to maintain backward compatibility. We should remove it 
// when people start using a more recent mozilla build.
//////////////////////////////////////////////////////////////////////////
function updateGroupmarkMenuitem(id)
{
  const disabled = gBrowser.browsers.length == 1;
  document.getElementById(id).setAttribute("disabled", disabled);
}
//////////////////////////////////////////////////////////////////////////
function BrowserViewSourceOfURL(url, charset, pageCookie)
{
  if (readMyPref("multizilla.newtabfor.view-source", "bool", false)) {
    var tab = null;
    var loadFromURL = true;
    url = 'view-source:' + url.replace(/view-source:/ig, '');
    var browser = checkForBlankTab();
    tab = preventDupeTab(url, false, gBrowser);
    if (tab) {
      gBrowser.selectedTab = tab;
      return;
    }
    try {
      if (typeof(pageCookie) == "object") {
        if (browser)
          tab = gBrowser.getTabForBrowser(browser);
        else
          tab = gBrowser.addTab(null, null, null, "restoreTab");
        gBrowser.selectedTab = tab;
        var PageLoader = getBrowser().webNavigation.QueryInterface(Components.interfaces.nsIWebPageDescriptor);
        PageLoader.LoadPage(pageCookie, Components.interfaces.nsIWebPageDescriptor.DISPLAY_AS_SOURCE);
        loadFromURL = false;
      }
    } catch(ex) { 
	}
    if (loadFromURL) {
      tab = browser ? gBrowser.getTabForBrowser(browser) : gBrowser.selectedTab;
      gBrowser.selectedTab = tab;
      loadURI(url);
    }
  }
  else {
    openDialog("chrome://navigator/content/viewSource.xul", "_blank",
               "scrollbars,resizable,chrome,dialog=no", url, charset, pageCookie);
  }
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroupFromResource(resource, datasource)
{
  var urlProperty = RDF.GetResource("http://home.netscape.com/NC-rdf#URL");
  var rdfContainer = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
  rdfContainer.Init(datasource, resource);
  var containerChildren = rdfContainer.GetElements();
  var index = 0;

  while (containerChildren.hasMoreElements()) {
    resource = containerChildren.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var target = datasource.GetTarget(resource, urlProperty, true);
    if (target) {
      var URL = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      if (URL /* && URL != 'about:blank' */ ) {
        if (!preventDupeTab(URL)) {
          if (index == 0)
            gBrowser.loadURI(URL);
          else 
            gBrowser.addTab(URL);
          index++;    
        }
      }
    }
  }  
  if (index == 0)
    return; // If the bookmark group was completely invalid, just bail.

  var tabCount = gBrowser.mPanelContainer.childNodes.length-1;
  var inBackground = pref.getBoolPref("browser.tabs.loadInBackground") ? 0 : tabCount;
  var tabs = gBrowser.mTabContainer.childNodes;
  gBrowser.selectedTab = tabs[inBackground];
}
//////////////////////////////////////////////////////////////////////////
// This modified version can handle multiple pref settings
//////////////////////////////////////////////////////////////////////////
function addPrefListener(observer)
{
  var domains = ("domains" in observer) ? observer.domains : [observer.domain];
  try {
    var pbi = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    for (var i = 0; i < domains.length; i++)
      pbi.addObserver(domains[i], observer, false);
  } catch(ex) {
    dump("Failed to observe prefs: " + ex + "\n");
  }
}
//////////////////////////////////////////////////////////////////////////
// Fill in tooltips for personal toolbar (older versions of navigator.js)
//////////////////////////////////////////////////////////////////////////
function FillInPTTooltip(tipElement) // for mozilla v1.4
{
  var title = tipElement.label;
  var url = tipElement.statusText;

  if (!title && !url)
    return false;

  var tooltipTitle = document.getElementById("ptTitleText");
  var tooltipUrl = document.getElementById("ptUrlText"); 

  if (title && title != url) {
    tooltipTitle.removeAttribute("hidden");
    tooltipTitle.setAttribute("value", title);
  } else  {
    tooltipTitle.setAttribute("hidden", "true");
  }
  if (url) {
    tooltipUrl.removeAttribute("hidden");
    tooltipUrl.setAttribute("value", url);
  } else {
    tooltipUrl.setAttribute("hidden", "true");
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'updateOverflowMenu' in bookmarksMenu.js
//////////////////////////////////////////////////////////////////////////
BookmarksToolbar.updateOverflowMenu = function(aMenuPopup)
{
   var hbox = document.getElementById("bookmarks-ptf");
   // There will be two menu items missing from the overflow menu, without this modification
   // We replace mozilla's template, this is why we have two extra childnodes,
   // childNodes[0] = tooltip and childNodes[1] = our modified template
   for (var i = 2; i < hbox.childNodes.length; i++) {
     var button = hbox.childNodes[i];
     var menu = aMenuPopup.childNodes[(i-2)];
     if (menu.hidden == button.collapsed)
       menu.hidden = !menu.hidden;
   }
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'StatusbarViewPopupManager()' in navigator.js
// This opens the more powerful permission manager of MultiZilla.
//////////////////////////////////////////////////////////////////////////
function StatusbarViewPopupManager()
{
  var hostPort = "";
  var sourceURI = getBrowser().selectedBrowser.currentURI;

  try {
    hostPort = (sourceURI.spec.match(/file:/i)) ? "file:" : sourceURI.hostPort;
  }
  catch(ex) { 
    hostPort = sourceURI.spec;
  }
  viewPermissionManager("popupManager", hostPort);
}
//////////////////////////////////////////////////////////////////////////
// Replacement for 'gotoHistoryIndex()' in navigator.js
//////////////////////////////////////////////////////////////////////////
function gotoHistoryIndex(aEvent)
{
  var index = aEvent.originalTarget.getAttribute("index");
  if (!index)
    return false;

  if (index == "back")
    gBrowser.goBackGroup();
  else if (index ==  "forward")
    gBrowser.goForwardGroup();
  else {
    if (aEvent.button == 1) { // a middle-click on a history entry will be opened in a new tab!
      var popup = aEvent.originalTarget.parentNode;
      var tabContextMenu = (popup.parentNode.nodeName == "xul:menu") ? true : false; // Called from tab context menu?
      var sourceTab = tabContextMenu ? gBrowser.mContextTab : gBrowser.selectedTab;
      var browser = gBrowser.getBrowserForTab(sourceTab);
      var sessionHistory = browser.sessionHistory;
      var sourceIndex = sessionHistory.index; // Backup index of sourceTab
      var newIndex = aEvent.originalTarget.getAttribute("index"); // Get selected index
      var historyEntry = sessionHistory.getEntryAtIndex(newIndex, true); // This also updates the index!

      // Don't allow blank tabs to be duplicated. What the heck is "about://blank/" ??
      if (historyEntry.URI.spec == "about:blank" || historyEntry.URI.spec == "about://blank/") {
        sessionHistory.getEntryAtIndex(sourceIndex, true); // Restore original index
        return false;
      }
      popup.hidePopup(); // Close the popup/menupopup/xul:menupopup

      if (tabContextMenu) {
        // Set menu item 'Tab History' inactive state and close tab context menu
        aEvent.target.parentNode.setAttribute("_moz-menuactive", false);
        popup = document.getElementById("tabContextMenu");
        popup.hidePopup();
      }
      gBrowser.duplicateTab(sourceTab, false);
      sessionHistory.getEntryAtIndex(sourceIndex, true); // Restore original index
      return true;
    }
    try {
      getWebNavigation().gotoIndex(index);
    }
    catch(ex) {
      return false;
    }
  }
  return true;
}
var gLineNumber = 0;
var gLastLineNumber = 0;
const nsISelectionPrivate = Components.interfaces.nsISelectionPrivate;
const nsISelectionController = Components.interfaces.nsISelectionController;
//////////////////////////////////////////////////////////////////////////
// Modified copy of 'ViewSourceGoToLine()' in viewsource.js
//////////////////////////////////////////////////////////////////////////
function ViewSourceGoToLine()
{
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                .getService(Components.interfaces.nsIPromptService);
  var viewSourceBundle = srGetStrBundle('chrome://navigator/locale/viewSource.properties');
  var input = {value:gLastLineNumber};

  for (;;) {
    var ok = promptService.prompt(window, viewSourceBundle.GetStringFromName('goToLineTitle'),
                                  viewSourceBundle.GetStringFromName('goToLineText'), input, 
                                  null, {value:0});

    if (!ok) 
      return;

    var line = parseInt(input.value);

    if (!(line > 0)) {
      promptService.alert(window, viewSourceBundle.GetStringFromName('invalidInputTitle'),
                          viewSourceBundle.GetStringFromName('invalidInputText'));
      continue;
    }
    gLineNumber = line;
    var found = mzGoToLine();

    if (found) {
      break;
    }
    promptService.alert(window, viewSourceBundle.GetStringFromName('outOfRangeTitle'),
                        viewSourceBundle.GetStringFromName('outOfRangeText'));
  }
}
//////////////////////////////////////////////////////////////////////////
// Modified copy of 'goToLine()' in viewsource.js
//////////////////////////////////////////////////////////////////////////
function mzGoToLine()
{
  var pre;
  var line = parseInt(gLineNumber);
  var viewsource = window._content.document.body;

  for (var lbound = 0, ubound = viewsource.childNodes.length; ; ) {
    var middle = (lbound + ubound) >> 1;
    pre = viewsource.childNodes[middle];
    var firstLine = parseInt(pre.id.substring(4));
    if (lbound == ubound - 1)
      break;
    if (line >= firstLine)
      lbound = middle;
	else
      ubound = middle;
  }
  var result = {};
  var found = mzFindLocation(pre, line, null, -1, false, result);

  if (!found)
    return false;

  var selection = window._content.getSelection();
  selection.removeAllRanges();
  selection.QueryInterface(nsISelectionPrivate).interlinePosition = true;
  selection.addRange(result.range);

  if (!selection.isCollapsed) {
    selection.collapseToEnd();
    var offset = result.range.startOffset;
    var node = result.range.startContainer;
    if (offset < node.data.length)
      selection.extend(node, offset);
    else {
      node = node.nextSibling ? node.nextSibling : node.parentNode.nextSibling;
      selection.extend(node, 0);
    }
  }
  var selCon = getBrowser().docShell
    .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
    .getInterface(Components.interfaces.nsISelectionDisplay)
    .QueryInterface(nsISelectionController);  
  selCon.setDisplaySelection(nsISelectionController.SELECTION_ON);
  selCon.setCaretEnabled(true);
  selCon.setCaretVisibilityDuringSelection(true);
  selCon.scrollSelectionIntoView(nsISelectionController.SELECTION_NORMAL,
                                 nsISelectionController.SELECTION_FOCUS_REGION, true);

  getBrowser().removeEventListener("load", mzGoToLine, true);
  gLastLineNumber = gLineNumber;
  return true;
}
//////////////////////////////////////////////////////////////////////////
// Modified copy of 'findLocation()' in viewsource.js
//////////////////////////////////////////////////////////////////////////
function mzFindLocation(pre, line, node, offset, interlinePosition, result)
{
  if (node && !pre)
    for (pre = node; pre.nodeName != "PRE"; pre = pre.parentNode);

  var curLine = parseInt(pre.id.substring(4));
  var treewalker = window._content.document.createTreeWalker(pre, NodeFilter.SHOW_TEXT, null, false);
  var firstCol = 1;
  var found = false;

  for (var textNode = treewalker.firstChild(); textNode && !found; textNode = treewalker.nextNode()) {
    var lineArray = textNode.data.split(/\n/);
    var lastLineInNode = curLine + lineArray.length - 1;

    if (node ? (textNode != node) : (lastLineInNode < line)) {
      if (lineArray.length > 1)
        firstCol = 1;
      firstCol += lineArray[lineArray.length - 1].length;
      curLine = lastLineInNode;
      continue;
    }
    for (var i = 0, curPos = 0; i < lineArray.length; curPos += lineArray[i++].length + 1) {
      if (i > 0)
        curLine++;
      if (node) {
        if (offset >= curPos && offset <= curPos + lineArray[i].length) {
          if (i > 0 && offset == curPos && !interlinePosition) {
            result.line = curLine - 1;
            var prevPos = curPos - lineArray[i - 1].length;
            result.col = (i == 1 ? firstCol : 1) + offset - prevPos;
          } 
          else {
            result.line = curLine;
            result.col = (i == 0 ? firstCol : 1) + offset - curPos;
          }
          found = true;
          break;
        }
      } 
      else {
        if (curLine == line && !("range" in result)) {
          result.range = document.createRange();
          result.range.setStart(textNode, curPos);
          result.range.setEndAfter(pre.lastChild);
        } 
        else if (curLine == line + 1) {
          result.range.setEnd(textNode, curPos - 1);
          found = true;
          break;
        }
      }
    }
  }
  return found;
}
////////////////////////////////////////////////////////////////////////////////
function mzSelectErrorInSource()
{
  window._content.focus();
  if (mzGoToLine > 0)
    getBrowser().addEventListener("load", mzGoToLine, true);
  // We don't want the location bar focused!
  setTimeout(WindowFocusTimerCallback, 0, _content);
}
//////////////////////////////////////////////////////////////////////////
function getBrowserForDocument(aDocument)
{  
  var browsers = getBrowser().browsers;

  for (var i = 0; i < browsers.length; i++) {
    if (browsers[i].contentDocument == aDocument)
      return browsers[i];
    else if (_content.frames.length) {
      for (var frame_nr = 0; frame_nr < _content.frames.length; frame_nr++) {
        if (_content.frames[frame_nr].length) { // deep nested
          if (isFrameDocumentContainer(_content.frames[frame_nr], aDocument))
            return browsers[i];
        }
        if (_content.frames[frame_nr].document == aDocument)
          return browsers[i];
      }
    }
  }
  return null;
}
//////////////////////////////////////////////////////////////////////////
function isFrameDocumentContainer(aFrame, aDocument)
{
  if (!aFrame || !aDocument)
    return false;

  for (var i = 0; i < aFrame.length; i++) {
    if (aFrame.frames[i].length) {
      if (isFrameDocumentContainer(aFrame, aDocument)) // recursive call
        return true;
    }
    if (aFrame.frames[i].document == aDocument)
      return true;
  }
  return false;
}